/* file: "c_intf.c" */

/* Copyright (C) 1994-1996 by Marc Feeley, All Rights Reserved. */

/* This module implements the conversion functions for the C interface */

#define ___VERSION 9
#include "gambit.h"
___BEGIN_MODULE

#include "setup.h"
#include "mem.h"

/* Some compilers don't accept "signed" characters... */
#define signed

#define ___SUBTYPEDDATA(x)((___WORD*)((x)-___tSUBTYPED+___WS))

static ___WORD ___temp;

___WORD *alloc_words_from_heap(n)
int n;
{
  ___WORD *result;
  pstate->hp += n;
  if (pstate->hp > pstate->hl)
    ___heap_limit ();
  else
    pstate->hp -= n;
  result = pstate->hp;
  pstate->hp += n;
  return result;
}

___WORD alloc_flonum(x)
double x;
{
#if ___WS == 4

  pstate->hp += ___FLONUM_SIZE + 2;
  if (pstate->hp > pstate->hl)
    {
      ___heap_limit ();
      pstate->hp += ___FLONUM_SIZE + 2;
    }
  if (((___WORD)pstate->hp&7) == 0)
    return ___FLONUM_SETUP((pstate->hp-___FLONUM_SIZE-1),x);
  else
    return ___FLONUM_SETUP((pstate->hp-___FLONUM_SIZE-2),x);

#else

  pstate->hp += ___FLONUM_SIZE + 1;
  if (pstate->hp > pstate->hl)
    {
      ___heap_limit ();
      pstate->hp += ___FLONUM_SIZE + 1;
    }
  return ___FLONUM_SETUP((pstate->hp-___FLONUM_SIZE-1),x);

#endif
}

___WORD alloc_bvector(n,subtype)
unsigned long n;
unsigned int subtype;
{
  ___WORD result, *ptr;
  ptr = alloc_words_from_heap( ___WORDS(n)+1 );
  result = ___TAG(ptr,___tSUBTYPED);
  ___HEADER(result)=___MAKE_HD_BYTES(n,subtype);
  return result;
}

___WORD alloc_string(s)
char *s;
{
  ___WORD result;
  int i;
  i = 0;
  while (s[i] != '\0') i++;
  result = alloc_bvector(i+1,___sSTRING);
  while (i >= 0)
    {
      ___STRINGSET(result,___FIX(i),___CHR(s[i]))
      i--;
    }
  return result;
}

/* Note: the Scheme to C conversion functions must NOT allocate memory */

int ___scmobj_to_char(obj,x)
___WORD obj;
char *x;
{
  if (___CHARP(obj))
    {
      *x = ___INT(obj);
      return 0;
    }
  else
    return 1;
}

int ___scmobj_to_schar(obj,x)
___WORD obj;
signed char *x;
{
  if (___CHARP(obj))
    {
      *x = ___INT(obj);
      return 0;
    }
  else
    return 1;
}

int ___scmobj_to_uchar(obj,x)
___WORD obj;
unsigned char *x;
{
  if (___CHARP(obj))
    {
      *x = ___INT(obj);
      return 0;
    }
  else
    return 1;
}

int ___scmobj_to_short(obj,x)
___WORD obj;
short *x;
{
  long val;
  if (___scmobj_to_long(obj,&val))
    return 1;
  else
    {
      *x = val;
      return 0;
    }
}

int ___scmobj_to_ushort(obj,x)
___WORD obj;
unsigned short *x;
{
  unsigned long val;
  if (___scmobj_to_ulong(obj,&val))
    return 1;
  else
    {
      *x = val;
      return 0;
    }
}

int ___scmobj_to_int(obj,x)
___WORD obj;
int *x;
{
  long val;
  if (___scmobj_to_long(obj,&val))
    return 1;
  else
    {
      *x = val;
      return 0;
    }
}

int ___scmobj_to_uint(obj,x)
___WORD obj;
unsigned int *x;
{
  unsigned long val;
  if (___scmobj_to_ulong(obj,&val))
    return 1;
  else
    {
      *x = val;
      return 0;
    }
}

int ___scmobj_to_long(obj,x)
___WORD obj;
long *x;
{
  if (___FIXNUMP(obj))
    {
      *x = ___INT(obj);
      return 0;
    }
  else
    return 1;
}

int ___scmobj_to_ulong(obj,x)
___WORD obj;
unsigned long *x;
{
  if (___FIXNUMP(obj))
    {
      *x = ___INT(obj);
      return 0;
    }
  else
    return 1;
}

int ___scmobj_to_float(obj,x)
___WORD obj;
float *x;
{
  if (___FLONUMP(obj))
    {
      *x = ___FLOUNBOX(obj);
      return 0;
    }
  else
    return 1;
}

int ___scmobj_to_double(obj,x)
___WORD obj;
double *x;
{
  if (___FLONUMP(obj))
    {
      *x = ___FLOUNBOX(obj);
      return 0;
    }
  else
    return 1;
}

int ___scmobj_to_pointer(obj,x)
___WORD obj;
void **x;
{
  if (___FALSEP(obj))
    {
      *x = 0;
      return 0;
    }
  else if (___TESTSUBTYPE(obj,___sPOINTER))
    {
      *x = (void*)*___BODY_AS(obj,___tSUBTYPED);
      return 0;
    }
  else
    return 1;
}

int ___scmobj_to_boolean(obj,x)
___WORD obj;
int *x;
{
  *x = !___FALSEP(obj);
  return 0;
}

int ___scmobj_to_string(obj,x)
___WORD obj;
char **x;
{
  if (___FALSEP(obj))
    {
      *x = 0;
      return 0;
    }
  else if (___STRINGP(obj))
    {
      *x = (char*)___SUBTYPEDDATA(obj);
      return 0;
    }
  else
    return 1;
}

int ___char_to_scmobj(x,obj)
char x;
___WORD *obj;
{
  *obj = ___CHR(x);
  return 0;
}

int ___schar_to_scmobj(x,obj)
signed char x;
___WORD *obj;
{
  *obj = ___CHR(x);
  return 0;
}

int ___uchar_to_scmobj(x,obj)
unsigned char x;
___WORD *obj;
{
  *obj = ___CHR(x);
  return 0;
}

int ___short_to_scmobj(x,obj)
short x;
___WORD *obj;
{
  *obj = ___FIX(x);
  return 0;
}

int ___ushort_to_scmobj(x,obj)
unsigned short x;
___WORD *obj;
{
  *obj = ___FIX(x);
  return 0;
}

int ___int_to_scmobj(x,obj)
int x;
___WORD *obj;
{
  *obj = ___FIX(x);
  return 0;
}

int ___uint_to_scmobj(x,obj)
unsigned int x;
___WORD *obj;
{
  *obj = ___FIX(x);
  return 0;
}

int ___long_to_scmobj(x,obj)
long x;
___WORD *obj;
{
  *obj = ___FIX(x);
  return 0;
}

int ___ulong_to_scmobj(x,obj)
unsigned long x;
___WORD *obj;
{
  *obj = ___FIX(x);
  return 0;
}

int ___float_to_scmobj(x,obj)
float x;
___WORD *obj;
{
  *obj = alloc_flonum((double)x);
  return 0;
}

int ___double_to_scmobj(x,obj)
double x;
___WORD *obj;
{
  *obj = alloc_flonum(x);
  return 0;
}

int ___pointer_to_scmobj(x,obj)
void *x;
___WORD *obj;
{
  if (x == 0)
    *obj = ___FAL;
  else
    {
      ___WORD result;
      result = alloc_bvector(___WS,___sPOINTER);
      *___BODY_AS(result,___tSUBTYPED) = (___WORD)x;
      *obj = result;
    }
  return 0;
}

int ___boolean_to_scmobj(x,obj)
int x;
___WORD *obj;
{
  if (x)
    *obj = ___TRU;
  else
    *obj = ___FAL;
  return 0;
}

int ___string_to_scmobj(x,obj)
char *x;
___WORD *obj;
{
  if (x == 0)
    *obj = ___FAL;
  else
    *obj = alloc_string(x);
  return 0;
}
