/* file: "mem.h" */

/* Copyright (C) 1994-1996 by Marc Feeley, All Rights Reserved. */

/* Memory allocation parameters: */

#define ___MIN_NB_SECTIONS 2
#define ___SECTION_HALFSIZE 65536
#define ___SEMISPACE_FUDGE  4096
#define ___OVERFLOW_RESERVE 32768
#define ___STACK_SIZE       8192
#define ___STACK_FUDGE      4096

extern long ___semispace_fudge;  /* size of  semispace fudge area in words */
extern long ___overflow_reserve; /* words reserved for heap overflows      */
extern long ___stack_size;       /* size of stack in words                 */
extern long ___stack_fudge;      /* size of stack fudge area in words      */

extern ___processor pstate; /* processor state (e.g. regs, allocation ptrs) */

extern void ___setup_mem (/* max_heap_len, gc_hook */);
extern int ___gc ();
extern int ___heap_limit ();

extern void *___malloc_aligned_block (/* size, multiplier, modulus */);
extern void ___free_aligned_block (/* ptr */);

extern ___WORD ___alloc_scmobj (/* subtype, bytes, kind */);
extern ___WORD ___make_pair (/* car, cdr, kind */);
extern ___WORD ___make_vector (/* length, init, kind */);
extern ___WORD ___make_string (/* length, init, kind */);
extern ___WORD ___string_to_scheme (/* str, kind */);
extern ___WORD ___double_to_scheme (/* val, kind */);
extern void ___still_obj_refcount_inc (/* obj */);
extern void ___still_obj_refcount_dec (/* obj */);
