/* This file is used to determine a number of parameters that depend on */
/* the host environment and C compiler.                                 */

#include "run/gambit.h"

#ifdef sparc
SETTING__o=".o"
SETTING__a=".a"
SETTING_GSCFLAGS=""
SETTING_LDFLAGS=""
SETTING_CC_PROG1="\\\"cc -c -D___DYNAMIC_LINK -o \\\""
SETTING_CC_PROG2="\\\".o \\\""
SETTING_CC_PROG3="\\\".c\\\""
#include <dlfcn.h>
#ifdef RTLD_NOW
SETTING_LD_PROG1="\\\"/usr/ccs/bin/ld -G -o \\\""
SETTING_LD_PROG2="\\\" \\\""
SETTING_LD_PROG3="\\\".o\\\""
#ifdef __GNUC__
SETTING_CC="gcc -O1 -D___SINGLE_HOST"
#else
SETTING_CC="cc -xO1 -D___SINGLE_HOST"
#endif
SETTING_LIBS="-lm -ldl"
#else
SETTING_LD_PROG1="\\\"/usr/bin/ld -o \\\""
SETTING_LD_PROG2="\\\" \\\""
SETTING_LD_PROG3="\\\".o\\\""
#ifdef __GNUC__
SETTING_CC="gcc -O1 -D___SINGLE_HOST"
#else
SETTING_CC="cc -O1 -D___SINGLE_HOST"
#endif
SETTING_LIBS="-lm"
#endif
#endif

#ifdef sgi
SETTING__o=".o"
SETTING__a=".a"
SETTING_GSCFLAGS=""
#ifdef __GNUC__
SETTING_CC="gcc -O1 -D___SINGLE_HOST"
#else
SETTING_CC="cc -Wf,-XNg4000,-XNd16000,-XNp8000 -call_shared -D___SINGLE_HOST"
#endif
SETTING_LDFLAGS=""
SETTING_LIBS="-lm"
SETTING_CC_PROG1="\\\"cc -c -D___DYNAMIC_LINK -o \\\""
SETTING_CC_PROG2="\\\".o \\\""
SETTING_CC_PROG3="\\\".c\\\""
SETTING_LD_PROG1="\\\"/usr/bin/ld -shared -o \\\""
SETTING_LD_PROG2="\\\" \\\""
SETTING_LD_PROG3="\\\".o\\\""
#endif

#ifdef __alpha
#undef __GNUC__
#ifdef ___I64
SETTING__o=".o"
SETTING__a=".a"
SETTING_GSCFLAGS=""
#ifdef __GNUC__
SETTING_CC="gcc -O1 -D___SINGLE_HOST"
#else
SETTING_CC="cc -call_shared -D___SINGLE_HOST"
#endif
SETTING_LDFLAGS=""
SETTING_LIBS="-lm"
SETTING_CC_PROG1="\\\"cc -shared -c -D___DYNAMIC_LINK -o \\\""
SETTING_CC_PROG2="\\\".o \\\""
SETTING_CC_PROG3="\\\".c\\\""
SETTING_LD_PROG1="\\\"/usr/bin/ld -shared -expect_unresolved __exc_\\* -o \\\""
SETTING_LD_PROG2="\\\" \\\""
SETTING_LD_PROG3="\\\".o\\\""
#else
SETTING__o=".o"
SETTING__a=".a"
SETTING_GSCFLAGS=""
SETTING_CC="cc -w -call_shared -D___SINGLE_HOST"
SETTING_LDFLAGS="-taso"
SETTING_LIBS="-lm"
SETTING_CC_PROG1="\\\"cc -w -shared -c -D___DYNAMIC_LINK -o \\\""
SETTING_CC_PROG2="\\\".o \\\""
SETTING_CC_PROG3="\\\".c\\\""
SETTING_LD_PROG1="\\\"/usr/bin/ld -shared -taso -expect_unresolved __exc_\\* -o \\\""
SETTING_LD_PROG2="\\\" \\\""
SETTING_LD_PROG3="\\\".o\\\""
#endif
#endif

#ifdef hpux
SETTING__o=".o"
SETTING__a=".a"
SETTING_GSCFLAGS=""
#ifdef __GNUC__
SETTING_CC="gcc -O1 -D___SINGLE_HOST"
#else
SETTING_CC="cc +O1 -D___SINGLE_HOST"
#endif
SETTING_LDFLAGS=""
SETTING_LIBS="-lm -ldld"
SETTING_CC_PROG1="\\\"cc +z -c -D___DYNAMIC_LINK -o \\\""
SETTING_CC_PROG2="\\\".o \\\""
SETTING_CC_PROG3="\\\".c\\\""
SETTING_LD_PROG1="\\\"/bin/ld -b -o \\\""
SETTING_LD_PROG2="\\\" \\\""
SETTING_LD_PROG3="\\\".o\\\""
#endif

#ifdef _AIX
SETTING__o=".o"
SETTING__a=".a"
SETTING_GSCFLAGS=""
#ifdef __GNUC__
SETTING_CC="gcc -O1 -D___SINGLE_HOST"
#else
SETTING_CC="cc -D___SINGLE_HOST"
#endif
SETTING_LDFLAGS=""
SETTING_LIBS="-lm"
SETTING_CC_PROG1="0"
SETTING_CC_PROG2="0"
SETTING_CC_PROG3="0"
SETTING_LD_PROG1="0"
SETTING_LD_PROG2="0"
SETTING_LD_PROG3="0"
#endif

#ifdef linux
SETTING__o=".o"
SETTING__a=".a"
SETTING_GSCFLAGS=""
SETTING_CC="gcc -O1 -rdynamic -D___SINGLE_HOST"
SETTING_LDFLAGS=""
SETTING_LIBS="-lm -ldl"
SETTING_CC_PROG1="\\\"cc -rdynamic -c -D___DYNAMIC_LINK -o \\\""
SETTING_CC_PROG2="\\\".o \\\""
SETTING_CC_PROG3="\\\".c\\\""
SETTING_LD_PROG1="\\\"/usr/bin/ld -shared -o \\\""
SETTING_LD_PROG2="\\\" \\\""
SETTING_LD_PROG3="\\\".o\\\""
#endif

#ifdef _MSC_VER
SETTING__o=".obj"
SETTING__a=".lib"
SETTING_GSCFLAGS=""
SETTING_CC="cl -nologo -Oityb1 -Gs -D__WINDOWS__ -D___SINGLE_HOST"
SETTING_LDFLAGS=""
SETTING_LIBS=""
SETTING_CC_PROG1="\\\"cl -nologo -Oityb1 -Gs -D__WINDOWS__ -D___DYNAMIC_LINK -c -Fo\\\""
SETTING_CC_PROG2="\\\".obj \\\""
SETTING_CC_PROG3="\\\".c\\\""
SETTING_LD_PROG1="\\\"link -nologo -nodefaultlib -noentry -dll -out:\\\""
SETTING_LD_PROG2="\\\" \\\""
SETTING_LD_PROG3="\\\".obj\\\""
#endif

#ifdef __WATCOMC__
SETTING__o=".obj"
SETTING__a=".lib"
SETTING_GSCFLAGS=""
SETTING_CC="wcl386 -oetir -s -5 -fp3 -bd -bt=windows -D___SINGLE_HOST"
SETTING_LDFLAGS=""
SETTING_LIBS=""
SETTING_CC_PROG1="\\\"wcl386 -oetir -s -5 -fp3 -bd -bt=windows -D___DYNAMIC_LINK -c -fo\\\""
SETTING_CC_PROG2="\\\".obj \\\""
SETTING_CC_PROG3="\\\".c\\\""
SETTING_LD_PROG1="\\\"wlink \\\""
SETTING_LD_PROG2="\\\" \\\""
SETTING_LD_PROG3="\\\".obj\\\""
#endif

#ifdef MACHTEN
SETTING__o=".o"
SETTING__a=".a"
SETTING_GSCFLAGS=""
SETTING_CC="cc"
SETTING_LDFLAGS=""
SETTING_LIBS="-lm"
SETTING_CC_PROG1="0"
SETTING_CC_PROG2="0"
SETTING_CC_PROG3="0"
SETTING_LD_PROG1="0"
SETTING_LD_PROG2="0"
SETTING_LD_PROG3="0"
#endif
